/*
 * file: ~/dat112/uppg3/mystrings.c
 *
 * Created by Ola Mrtensson, ola@matrix.df.lth.se
 *
 * Time-stamp: <96/03/04 19:37:36 ola>
 *
 *
 * Routines of useable string operations
 *
 */

#define TRUE 1
#define EOS '\0'

/* purpose: Copies 'i' chacters starting from 'j' from string 'in' => 'out'
 *          in - input string
 *          out - output string
 *          j - starting index
 *          i - number of character copied
 * outputs: out - new string ending with EOS
 */
void mid(char *out,char *in,int j,int i)
{
  int k;

  if (strlen(in)-j+1<i)
    i=strlen(in)-j+1;

  for(k=j-1;k<i+j-1;k++)
    out[k-j+1] = in[k];

  out[k-j+1] = EOS;
} /* End mid*/


/* purpose: copy string starting from given index
 *          any characters will be overwritten
 *          No check if output is large enough
 * input:   out   - destination string
 *          in    - string to be copied
 *          start - start copy from this index
 * output:  out - copied
 */
void strlncpy(char *out, char *in,int start)
{
  int i;

  for(i=start;i<strlen(in);i++)
    out[i-start]=in[i];
} /* End strlncpy */


/* purpose: reverse a string
 * input:   s - string
 * output:  s - modified
 */
void reverse(char *s)
{
  int i,j;
  char c;

  for (i=0,j=strlen(s)-1;i<j;i++,j--) {
    c = s[i];
    s[i] = s[j];
    s[j] =c;
  }
}


/* purpose: convert long interger to string
 * input:   n - long integer
 *          s - string
 * output:  s - modified string
 */
void ltoa (long n,char *s)
{
  int i=0;
  int forechar = 0;

  if (n<0) {
    forechar = TRUE;
    n = -n;
  }
  do {
    s[i++] = (n % 10) + '0';
  } while ((n /= 10) > 0);
  if (forechar)
    s[i++] = '-';

  s[i]=EOS;
  reverse(s);
}


/* purpose: convert interger to string
 * input:   n - integer
 *          s - string
 * output:  s - modified string
 */
void itoa (long n, char *s)
{
  ltoa((long)(n),s);
}
